-- Lua As3Object metatable wrapper/Class definition
As3Object = {}
As3Object.obj = as3.toobject( {} )
As3Object.mt = {}

As3Object.mt.__index = function( t, k )

	local rval
	local objType
	
	if trace then printTrace("LUA:As3ObjectLib.lua::As3Object::__index : Entering with property " .. k) end
	
	if k == "_obj" then
		rval = t.obj
	else	
		objType = as3.type( t.obj[k] )
		if objType == "void" then
			return nil	
		end
		
		if trace then printTrace("LUA::As3ObjectLib.lua::As3Object::__index : objType for property " .. k .. " is " .. objType ) end

		if objType == "String" or objType == "int" or objType == "Number" or objType == "Boolean" then
			if trace then printTrace("LUA::As3ObjectLib.lua::As3Object::__index : Returning a lua primitive type from property " .. k ) end
			rval = as3.tolua( t.obj[k] )
		end
				
		if objType == "Array" or objType == "Vector" or objType == "__AS3__.vec::Vector.<Object>" then
			rval = t.obj[ k ]
		end
		
		if objType == "Object" then
			if trace then printTrace("LUA::As3ObjectLib.lua::As3Object::__index Object found, returning base As3 value from property " .. k ) end
			rval = As3Object:new(t.obj[k])
		end
		
		if objType == "builtin.as$0::MethodClosure" then 
			rval = t.obj[k]
		end
		
		if rval == nil then
			rval = As3Object:new( t.obj[k] )
		end

	end
	return rval 
end

As3Object.mt.__newindex = function( t, k, v)
	-- Test incoming property values to see if they're an as3 value or not

	if as3.isas3value( v ) then
		t.obj[k] = v
	else
		if type(k) == "table" then
			t.obj[k] = as3.toobject( v )
		elseif type(k) ~= "userdata" and type(k) ~= "thread" and type(k) ~= "function" then
			t.obj[k] = as3.toas3( v )
		end
	end
end

-- Create a new As3Object instance using the userdata object supplied
function As3Object:new( userdata )

	local objType = as3.type( userdata )
	self = {}
	if trace then printTrace("LUA::As3ObjectLib.lua::As3Object::new : Initializing new Lua As3Object with object " ) end
	self.obj = userdata
	setmetatable( self, As3Object.mt )
	return self
end

printTrace("LUA::As3ObjectLib.lua - Generic As3 Object support initialized")


